<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Root extends CI_Controller {

	public function __construct(){
        parent::__construct();
        $this->load->model('root_model','current_model');
		$this->load->helper(array('form','url'));
        
        //header('Location: '.base_url());
        }


    public function index()
    {
     
        $this->checkLogin();
        $data['drivers']=$this->current_model->GetLatestDrivers();
        $data['companies']=$this->current_model->GetLatestCompanies();
        $data['bookings']=$this->current_model->GetLatestBookings();
    	$this->load->view('root/dashboard',$data);
    }

     public function companies()
    {
        $this->checkLogin();
        $data['companies']= $this->current_model->GetCompanies();
        $data['states']= $this->current_model->GetStates();
        $this->load->view('root/companies',$data);
    }
     public function drivers()
    {
        $this->checkLogin();
        $data['drivers']= $this->current_model->GetDrivers();
        //echo $this->db->last_query();
        
        $this->load->view('root/drivers',$data);
    }

      public function faresetting()
    {
        $this->checkLogin();
        $data['faresetting']= $this->current_model->GetFareSetting();
        $this->load->view('root/fare-setting',$data);
    }

    public function SubmitFareSetting()
    {
        $submitArray = $this->input->post();
        // $price_per_mile=$this->input->post('price_per_mile');
        // $geographic_area=$this->input->post('geographic_area');
        // $gas_fuel_delivery_installs=$this->input->post('gas_fuel_delivery_installs');
        // $battery_delivery_installs=$this->input->post('battery_delivery_installs');
        // $tire_price_change=$this->input->post('tire_price_change');
        // $radius_value=$this->input->post('radius_value');
        // $submitArray=array('price_per_mile'=>$price_per_mile,'geographic_area'=>$geographic_area,'radius_value'=>$radius_value,'gas_fuel_delivery_installs'=>$gas_fuel_delivery_installs,'battery_delivery_installs'=>$battery_delivery_installs,'tire_price_change'=>$tire_price_change,'is_active'=>1,'is_deleted'=>0);

            $update =$this->db->query("update fare_setting set is_active='0' where 1=1");
            $this->db->insert('price_setting',$submitArray);

             redirect(site_url().'root/faresetting');

    }

    public function appusers()
    {
        $this->checkLogin();
        $data['appusers']= $this->current_model->GetAppUsers();
        $this->load->view('root/app-users',$data);
    }

    public function truckmaker()
    {
        $this->checkLogin();
        $data['makers']= $this->current_model->GetTruckMakers();
        $this->load->view('root/truck-makers',$data);
    }
    public function truckmodels()
    {
        $this->checkLogin();
        $data['models']= $this->current_model->GetModels();
        $this->load->view('root/models',$data);
    }
    public function trucktypes()
    {
        $this->checkLogin();
        $data['types']= $this->current_model->GetTypes();
        $this->load->view('root/truck-types',$data);
    }
    public function signin()
    {
    	$this->load->view('root/signin');
    }
    public function licensetypes()
    {
        $this->checkLogin();
        $data['types']= $this->current_model->GetLicenseTypes();
        $this->load->view('root/license-types',$data);
    }
    public function logout()
    {
        $user_data = $this->session->all_userdata();
        foreach ($user_data as $key => $value) {
            if ($key != 'admin_id' && $key != 'name' && $key != 'roll' ) {
                $this->session->unset_userdata($key);
            }
        }
        $this->session->sess_destroy();
        redirect(site_url().'root/signin');
    }

    public function doLogin()
    {

    	$admin_email=$this->input->post('email');
    	$password=$this->input->post('password');
        $result = $this->current_model->checkLogin($admin_email,$password);
       
    	if($result){
    		redirect(site_url().'root/');
    	}
    	else{
    	    $this->session->set_flashdata('error', 'Invalid Username || Password to Login');
    		redirect(site_url().'root/signin');
    	}

    }


    function checkLogin()
    {

            if($this->session->userdata('admin_id')==NULL)
            {redirect(site_url().'root/signin');}
    }


    public function SubmitCompanyAccount()
    {
        $posted= array();
        $company_name   = $this->input->post('company_name');
        $license_number  = $this->input->post('license_number');
        $company_address   = $this->input->post('company_address');
        $company_city  = $this->input->post('company_city');
        $company_email  = $this->input->post('company_email');
        $password  = $this->input->post('password');
        $state_id  = $this->input->post('state_id');
        $zip_code  = $this->input->post('zip_code');
        $company_number= $this->input->post('company_number');
        $tax_id=$this->input->post('tax_id');
        $last_signin=date('Y-m-d H:i:s');
        $signup_date=date("d/m/Y");
        $bank_account_holder=$this->input->post('bank_account_holder');
        $bank_account_number=$this->input->post('bank_account_number');
        $routing=$this->input->post('routing');
        $bank_name=$this->input->post('bank_name');
        $bank_address=$this->input->post('bank_address');

        $password=md5($password);
        $posted = array('company_name' => $company_name,'company_number'=>$company_number,'license_number'=>$license_number,'company_address'=>$company_address,'company_city'=>$company_city,'state_id'=>$state_id,'zip_code'=>$zip_code,' tax_id'=>$tax_id,'bank_account_holder'=>$bank_account_holder,'bank_account_number'=>$bank_account_number,'routing'=>$routing,'bank_name'=>$bank_name,'bank_address'=>$bank_address,'company_email'=>$company_email,'password'=>$password,'registration_date'=>$signup_date,'last_signin'=>'','is_approved'=>1,'is_deleted'=>0,'login_status'=>0 );
         $this->db->insert('companies',$posted);
         redirect(site_url().'root/companies');
    }
    
    public function InnactiveCompany($company_id)
    {
         $this->db->where('company_id',$company_id);
         $this->db->update('companies',array('is_approved'=>0));
         redirect(site_url().'root/companies');
        
    }
    
    
     public function ActiveCompany($company_id)
    {
         $this->db->where('company_id',$company_id);
         $this->db->update('companies',array('is_approved'=>1));
         redirect(site_url().'root/companies');
        
    }
    
    public function DeleteCompany($company_id)
    {
         $this->db->where('company_id',$company_id);
         $this->db->update('companies',array('is_deleted'=>1));
         redirect(site_url().'root/companies');
        
    }
    
     public function bookinglist()
    {
        $this->checkLogin();
        $data['bookings']= $this->current_model->GetBookings();
        $this->load->view('root/bookings',$data);
    }
    
      public function available_bookings()
    {
       
         $from=$this->input->post('start');
         $to=$this->input->post('end');
         $status=$this->input->post('status');
        
         $data['bookings']= $this->current_model->GetBookingSearch($from,$to,$status);
         $data['from']=$from;
         $data['to']=$to;
         $data['status']=$status;
        //echo $this->db->last_query();exit;
        $this->load->view('root/available_bookings',$data);
    }
    
      public function profile()
    {
       
        $data['profile']= $this->current_model->GetProfile();
        $this->load->view('root/profile',$data);
    }
    
    public function EditCompany()
    {
        echo $company_id= $this->input->get('compnay_id', TRUE);
        $this->checkLogin();
        $data['info']= $this->current_model->GetCompanyInfo($company_id);
        $data['states']= $this->current_model->GetStates();
        $this->load->view('root/company_edit',$data);
    }
    public function SubmitEditCompany()
    {
        $company_id= $this->input->post('company_id');
        
        $posted= array();
        $company_name   = $this->input->post('company_name');
        $license_number  = $this->input->post('license_number');
        $company_address   = $this->input->post('company_address');
        $company_city  = $this->input->post('company_city');
        $company_email  = $this->input->post('company_email');
        $password  = $this->input->post('password');
        $state_id  = $this->input->post('state_id');
        $zip_code  = $this->input->post('zip_code');
        $company_number= $this->input->post('company_number');
        $tax_id=$this->input->post('tax_id');
        $last_signin=date('Y-m-d H:i:s');
        $signup_date=date("d/m/Y");
        $bank_account_holder=$this->input->post('bank_account_holder');
        $bank_account_number=$this->input->post('bank_account_number');
        $routing=$this->input->post('routing');
        $bank_name=$this->input->post('bank_name');
        $bank_address=$this->input->post('bank_address');
        if(isset($password))
        {
             $password=md5($password);
             $posted = array('company_name' => $company_name,'company_number'=>$company_number,'license_number'=>$license_number,'company_address'=>$company_address,'company_city'=>$company_city,'state_id'=>$state_id,'zip_code'=>$zip_code,' tax_id'=>$tax_id,'bank_account_holder'=>$bank_account_holder,'bank_account_number'=>$bank_account_number,'routing'=>$routing,'bank_name'=>$bank_name,'bank_address'=>$bank_address,'company_email'=>$company_email,'password'=>$password,'registration_date'=>$signup_date,'is_approved'=>0 );
        
        }else
        {
            $posted = array('company_name' => $company_name,'company_number'=>$company_number,'license_number'=>$license_number,'company_address'=>$company_address,'company_city'=>$company_city,'state_id'=>$state_id,'zip_code'=>$zip_code,' tax_id'=>$tax_id,'bank_account_holder'=>$bank_account_holder,'bank_account_number'=>$bank_account_number,'routing'=>$routing,'bank_name'=>$bank_name,'bank_address'=>$bank_address,'company_email'=>$company_email,'registration_date'=>$signup_date,'last_signin'=>'','is_approved'=>0);
         
        }
        
         
         $this->db->where('company_id',$company_id);
         $this->db->update('companies',$posted);
         redirect(site_url().'root/companies');
        
    }
    
    
     public function DriverCreate()
    {
        $this->checkLogin();
        $data['dropdowns']=$this->dropdowns();
        $this->load->view('root/driver_add',$data);
    }
  public function dropdowns()
    {
    	//makers
    	$this->db->select('truck_maker.*');
        $this->db->from('truck_maker');
        $this->db->where('truck_maker.is_deleted',0);
        $makers=$this->db->get();
        $lst_maker = array();
    
        if($makers->num_rows()>0) {
    		foreach ($makers->result() as $k) {
    			$lst_maker[] = array('maker_id'=>$k->maker_id ,'maker_name'=>$k->maker_name);
    		}
    	} 
    	//truck_models
    
    	$this->db->select('truck_models.*');
        $this->db->from('truck_models');
        $this->db->where('truck_models.is_deleted',0);
        $models=$this->db->get();
        $lst_models = array();
    
        if($makers->num_rows()>0) {
    		foreach ($models->result() as $k) {
    			$lst_models[] = array('model_id'=>$k->model_id ,'model_name'=>$k->model_name);
    		}
    	} 
    
    	// states
    
    	$this->db->select('*');
        $this->db->from('states');
        $this->db->where('is_deleted',0);
        $states=$this->db->get();
        $lst_states = array();
    
        if($makers->num_rows()>0) {
    		foreach ($states->result() as $k) {
    			$lst_states[] = array('state_id'=>$k->state_id  ,'state_name'=>$k->state_name);
    		}
    	} 
    	// license_types
    
    	$this->db->select('license_types.*');
        $this->db->from('license_types');
        $this->db->where('license_types.is_deleted',0);
        $license_types=$this->db->get();
        $lst_license_types = array();
    
        if($license_types->num_rows()>0) {
    		foreach ($license_types->result() as $k) {
    			$lst_license_types[] = array('license_type_id'=>$k->license_type_id  ,'license_type_name'=>$k->license_type_name);
    		}
    	} 
    
    	// truck_type
    
    	$this->db->select('truck_type.*');
        $this->db->from('truck_type');
        $this->db->where('truck_type.is_deleted',0);
        $truck_type=$this->db->get();
        $lst_truck_type = array();
    
        if($truck_type->num_rows()>0) {
    		foreach ($truck_type->result() as $k) {
    			$lst_truck_type[] = array('truck_type_id'=>$k->truck_type_id  ,'type_name'=>$k->type_name);
    		}
    	}
    
    
    	// companies
    
    	$this->db->select('company_name,company_id');
        $this->db->from('companies');
        $this->db->where('companies.is_deleted',0);
        $companies=$this->db->get();
        $lst_companies = array();
    
        if($companies->num_rows()>0) {
    		foreach ($companies->result() as $k) {
    			$lst_companies[] = array('company_id'=>$k->company_id  ,'company_name'=>$k->company_name);
    		}
    	}
      	
    
      		$data['companies']=$lst_companies;
    		$data['truck_type']=$lst_truck_type;
    		$data['license_types']=$lst_license_types;
    		$data['states']=$lst_states;
    		$data['models']=$lst_models;
    		$data['makers']=$lst_maker;
    	
    	return $data;
    
    }


    function SubmitDriverProfile()
    {
        $services=$this->input->post('tws');
        $assistances=$this->input->post('rsa');
        
        $selected_assistance="";
        
        $selected_services="";
       
        foreach($services as $service)
        {
            $selected_services .=$service .", ";
            
        }
        foreach($assistances as $service)
        {
            $selected_assistance .=$service .", ";
            
        }
        
        $company_id = $this->input->post('company_id');
        $posted= array();
        $driver_name   = $this->input->post('driver_name');
        $driver_email  = $this->input->post('driver_email');
        $cell_number   = $this->input->post('cell_number');
        $license_number  = $this->input->post('license_number');
        $license_issue_date  = $this->input->post('license_issue_date');
        $password  = $this->input->post('password');
        $license_expiration_date  = $this->input->post('license_expiration_date');
        $date_of_birth  = $this->input->post('date_of_birth');
        $state_id= $this->input->post('state_id');
        $license_type_id=$this->input->post('license_type_id');
        $last_signin=date('Y-m-d H:i:s');
        $signup_date=date("d/m/Y");
        $bank_account_holder=$this->input->post('bank_account_holder');
        $bank_account_number=$this->input->post('bank_account_number');
        $routing_number=$this->input->post('routing_number');
        $bank_name=$this->input->post('bank_name');
        $bank_address=$this->input->post('bank_address');
        $tow_truck_make_id=$this->input->post('tow_truck_make_id');
        $tow_year=$this->input->post('tow_year');
        $tow_model_id=$this->input->post('tow_model_id');
        $tow_truck_type_id=$this->input->post('tow_truck_type_id');
		$tow_weigth=$selected_services;
		$roadside_assistance=$selected_assistance;
		
		$password=md5($password);

        $posted = array('driver_name' => $driver_name,'driver_email'=>$driver_email,'cell_number'=>$cell_number,'license_number'=>$license_number,'license_issue_date'=>$license_issue_date,'license_expiration_date'=>$license_expiration_date,'date_of_birth'=>$date_of_birth,'state_id'=>$state_id,'license_type_id'=>$license_type_id,'company_id'=>$company_id,'bank_account_holder'=>$bank_account_holder,'bank_account_number'=>$bank_account_number,'routing_number'=>$routing_number,'bank_name'=>$bank_name,'bank_address'=>$bank_address,'tow_truck_make_id'=>$tow_truck_make_id,'tow_year'=>$tow_year,'is_approved'=>1,'is_deleted'=>0,'login_status'=>0,'tow_model_id'=>$tow_model_id,'tow_truck_type_id'=>$tow_truck_type_id ,'tow_weight'=>$tow_weigth,'roadside_assistance'=>$roadside_assistance,'password'=>$password);
        $this->db->insert('drivers',$posted);
        redirect(site_url().'root/drivers');
    }
    
    
    function EditDriver()
    {
         $driver_id= $this->input->get('driver_id', TRUE);
         $this->checkLogin();
         $data['driver']=$this->current_model->GetDriverInfo($driver_id);
         $data['dropdowns']=$this->dropdowns();
         $this->load->view('root/driver_edit',$data);
        
    }
 
    function SubmitUpdateDriver()
    {
        $driver_id=$this->input->post('driver_id');
        $services=$this->input->post('tws');
        $assistances=$this->input->post('rsa');
        $selected_assistance="";
        $selected_services="";
       
        foreach($services as $service)
        {
            $selected_services .=$service .",";
        }
        
        foreach($assistances as $service)
        {
            $selected_assistance .=$service .",";
        }
        
        $posted= array();
        
        $driver_name   = $this->input->post('driver_name');
        $driver_email  = $this->input->post('driver_email');
        $cell_number   = $this->input->post('cell_number');
        $license_number  = $this->input->post('license_number');
        $license_issue_date  = $this->input->post('license_issue_date');
        $password  = $this->input->post('password');
        $license_expiration_date  = $this->input->post('license_expiration_date');
        $date_of_birth  = $this->input->post('date_of_birth');
        $state_id= $this->input->post('state_id');
        $license_type_id=$this->input->post('license_type_id');
        $last_signin=date('Y-m-d H:i:s');
        $signup_date=date("d/m/Y");
        $company_id=$this->input->post('company_id');
        $bank_account_holder=$this->input->post('bank_account_holder');
        $bank_account_number=$this->input->post('bank_account_number');
        $routing_number=$this->input->post('routing_number');
        $bank_name=$this->input->post('bank_name');
        $bank_address=$this->input->post('bank_address');
        $tow_truck_make_id=$this->input->post('tow_truck_make_id');
        $tow_year=$this->input->post('tow_year');
        $tow_model_id=$this->input->post('tow_model_id');
        $tow_truck_type_id=$this->input->post('tow_truck_type_id');
		$tow_weigth=$selected_services;
		$roadside_assistance=$selected_assistance;
		
		if(isset($password))
		{
		    $password=md5($password);
            $posted = array('driver_name' => $driver_name,'cell_number'=>$cell_number,'license_number'=>$license_number,'license_issue_date'=>$license_issue_date,'license_expiration_date'=>$license_expiration_date,'date_of_birth'=>$date_of_birth,'state_id'=>$state_id,'license_type_id'=>$license_type_id,'company_id'=>$company_id,'bank_account_holder'=>$bank_account_holder,'bank_account_number'=>$bank_account_number,'routing_number'=>$routing_number,'bank_name'=>$bank_name,'bank_address'=>$bank_address,'tow_truck_make_id'=>$tow_truck_make_id,'tow_year'=>$tow_year,'tow_model_id'=>$tow_model_id,'tow_truck_type_id'=>$tow_truck_type_id ,'tow_weight'=>$tow_weigth,'roadside_assistance'=>$roadside_assistance,'password'=>$password);
		}
		else
		{
		    $posted = array('driver_name' => $driver_name,'cell_number'=>$cell_number,'license_number'=>$license_number,'license_issue_date'=>$license_issue_date,'license_expiration_date'=>$license_expiration_date,'date_of_birth'=>$date_of_birth,'state_id'=>$state_id,'license_type_id'=>$license_type_id,'company_id'=>$company_id,'bank_account_holder'=>$bank_account_holder,'bank_account_number'=>$bank_account_number,'routing_number'=>$routing_number,'bank_name'=>$bank_name,'bank_address'=>$bank_address,'tow_truck_make_id'=>$tow_truck_make_id,'tow_year'=>$tow_year,'tow_model_id'=>$tow_model_id,'tow_truck_type_id'=>$tow_truck_type_id ,'tow_weight'=>$tow_weigth,'roadside_assistance'=>$roadside_assistance);
		}
		
		$this->db->where('driver_id',$driver_id);
        $this->db->update('drivers',$posted);
        redirect(site_url().'root/EditDriver?driver_id='.$driver_id);
        
     }
    
    
    public function DeleteDriver($driver_id)
    {
         $this->db->where('driver_id',$driver_id);
         $this->db->update('drivers',array('is_deleted'=>1));
         redirect(site_url().'root/drivers');
        
    }
    
     public function DisableDriver($driver_id)
    {
         $this->db->where('driver_id',$driver_id);
         $this->db->update('drivers',array('is_approved'=>0));
         redirect(site_url().'root/drivers');
        
    }
     public function EnableDriver($driver_id)
    {
         $this->db->where('driver_id',$driver_id);
         $this->db->update('drivers',array('is_approved'=>1));
         redirect(site_url().'root/drivers');
        
    }
    
    public function EnableAppUser($user_id)
    {
         $this->db->where('user_id',$user_id);
         $this->db->update('app_users',array('is_varified'=>1));
         redirect(site_url().'root/appusers');
        
    }
    
     public function DisableAppUser($user_id)
    {
        
         $this->db->where('user_id',$user_id);
         $this->db->update('app_users',array('is_varified'=>0));
         
         redirect(site_url().'root/appusers');
        
    }
    
     public function DeleteBooking($booking_id)
    {
         $this->db->where('booking_id',$booking_id);
         $this->db->update('booking',array('is_deleted'=>1));
         redirect(site_url().'root/bookinglist');
        
    }
    
    
    public function UpdateProfile()
    {
        $user_name=$this->input->post('user_name');
        $user_email=$this->input->post('user_email');
        $password=$this->input->post('password');
        
        if(isset($password))
        {    $this->db->where('id',$this->session->userdata('admin_id'));
             $this->db->update('super_admin',array('user_name'=>$user_name,'email'=>$user_name,'password'=>$password));
        }else
        {
            $this->db->where('id',$this->session->userdata('admin_id'));
            $this->db->update('super_admin',array('user_name'=>$user_name,'email'=>$user_name));
            
        }
        
    }
    
    public function GetDashboardValues()
    {
        $data=$this->current_model->GetSumValues();
        echo json_encode($data);
        
        
    }
	
}