<?php 

require APPPATH . 'libraries/REST_Controller.php';
require_once 'vendor/autoload.php';

class Driver extends REST_Controller {
public function __construct() {
       parent::__construct();
       $this->load->database();
}



public function dropdowns_get()
{
	//makers
	$this->db->select('truck_maker.*');
    $this->db->from('truck_maker');
    $this->db->where('truck_maker.is_deleted',0);
    $makers=$this->db->get();
    $lst_maker = array();

    if($makers->num_rows()>0) {
		foreach ($makers->result() as $k) {
			$lst_maker[] = array('maker_id'=>$k->maker_id ,'maker_name'=>$k->maker_name);
		}
	} 
	//truck_models

	$this->db->select('truck_models.*');
    $this->db->from('truck_models');
    $this->db->where('truck_models.is_deleted',0);
    $models=$this->db->get();
    $lst_models = array();

    if($makers->num_rows()>0) {
		foreach ($models->result() as $k) {
			$lst_models[] = array('model_id'=>$k->model_id ,'model_name'=>$k->model_name);
		}
	} 

	// states

	$this->db->select('*');
    $this->db->from('states');
    $this->db->where('is_deleted',0);
    $states=$this->db->get();
    $lst_states = array();

    if($makers->num_rows()>0) {
		foreach ($states->result() as $k) {
			$lst_states[] = array('state_id'=>$k->state_id  ,'state_name'=>$k->state_name);
		}
	} 
	// license_types

	$this->db->select('license_types.*');
    $this->db->from('license_types');
    $this->db->where('license_types.is_deleted',0);
    $license_types=$this->db->get();
    $lst_license_types = array();

    if($license_types->num_rows()>0) {
		foreach ($license_types->result() as $k) {
			$lst_license_types[] = array('license_type_id'=>$k->license_type_id  ,'license_type_name'=>$k->license_type_name);
		}
	} 

	// truck_type

	$this->db->select('truck_type.*');
    $this->db->from('truck_type');
    $this->db->where('truck_type.is_deleted',0);
    $truck_type=$this->db->get();
    $lst_truck_type = array();

    if($truck_type->num_rows()>0) {
		foreach ($truck_type->result() as $k) {
			$lst_truck_type[] = array('truck_type_id'=>$k->truck_type_id  ,'type_name'=>$k->type_name);
		}
	}


	// companies

	$this->db->select('company_name,company_id');
    $this->db->from('companies');
    $this->db->where('companies.is_deleted',0);
    $companies=$this->db->get();
    $lst_companies = array();

    if($companies->num_rows()>0) {
		foreach ($companies->result() as $k) {
			$lst_companies[] = array('company_id'=>$k->company_id,'company_name'=>$k->company_name);
		}
	}
  	
  	else {
		$data['dropdowns'] =array();
		$data['msg'] = "error";
		$data['status'] = REST_Controller::HTTP_NOT_FOUND;
		$this->response($data, REST_Controller::HTTP_NOT_FOUND);
  	} 


  		$data['companies']=$lst_companies;
		$data['truck_type']=$lst_truck_type;
		$data['license_types']=$lst_license_types;
		$data['states']=$lst_states;
		$data['models']=$lst_models;
		$data['makers']=$lst_maker;
		$data['msg'] ="success";
		$data['status'] = REST_Controller::HTTP_OK;
		$this->response($data, REST_Controller::HTTP_OK);

}

public function truck_update_post()
{
   $posted= array();
   $tow_truck_make_id=$this->input->post('tow_truck_make_id');
   $tow_year=$this->input->post('tow_year');
   $tow_model_id=$this->input->post('tow_model_id');
   $tow_truck_type_id=$this->input->post('tow_truck_type_id');
   $tow_weigth=$this->input->post('tow_weigth');
   $roadside_assistance=$this->input->post('roadside_assistance');
   $cell_number=$this->input->post('cell_number');
   
  $posted = array('tow_truck_make_id'=>$tow_truck_make_id,
        'tow_year'=>$tow_year,'tow_model_id'=>$tow_model_id,'tow_truck_type_id'=>$tow_truck_type_id ,'tow_weight'=>$tow_weigth,
        'roadside_assistance'=>$roadside_assistance);
        
        if(isset($roadside_assistance) && isset($tow_weigth) && isset($tow_truck_type_id) && isset($tow_truck_make_id) ){

            $this->db->where('cell_number',$cell_number);
            $this->db->update('drivers',$posted);
            $data['data'] = $posted;
             $data['msg'] = "Truck Registration Updated.";
            $data['status'] =  REST_Controller::HTTP_OK;
          } 
          else
          {
             $data['data'] = $posted;
             $data['msg'] = "Incomplete Truck information";
             $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
          }

          $this->response($data, REST_Controller::HTTP_OK);
        
}

 public function driver_support_post()
{
    $data['booking_id'] = $this->input->post('booking_id');
    $data['driver_id'] = $this->input->post('driver_id');
    $data['support_text'] = $this->input->post('support_text');
    $data['createdDate'] = date('Y-m-d H:i:s');

    $inserted = $this->db->insert('support', $data);

    if ($inserted) {
        $response['msg'] = "Data saved successfully";
        $response['status'] = REST_Controller::HTTP_OK;
    } else {
        $response['msg'] = "Error saving data";
        $response['status'] = REST_Controller::HTTP_NOT_FOUND;
    }

    $this->response($response, REST_Controller::HTTP_OK);
}


    public function cancel_driver_order_post()
    {
        $data = array();
        $booking_id = $this->input->post('booking_id');
    
        $query = $this->db->query("SELECT * FROM booking WHERE booking_id = ? AND is_deleted = 0", array($booking_id));
        $result1 = $query->result();
    
        if ($query->num_rows() == 1) {
            $update_data = array('is_deleted' => 1 , 'booking_status' => 'cancel');
            $this->db->where('booking_id', $booking_id);
            $this->db->update('booking', $update_data);
    
            $data['booking_info'] = $update_data;
            $data['msg'] = "Booking canceled successfully";
            $data['status'] = REST_Controller::HTTP_OK;
        } else {
            $data['user_info'] = "";
            $data['msg'] = "Sorry! Unable to cancel booking or booking not found!";
            $data['status'] = REST_Controller::HTTP_NOT_FOUND;
        }
    
        $this->response($data, REST_Controller::HTTP_OK);
    }
    
     public function driver_rating_post()
    {
        $data = array();
        $booking_id   = $this->input->post('booking_id');
        $driver_rating   = $this->input->post('driver_rating');
        $driver_rating_text   = $this->input->post('driver_rating_text');
        $driver_id   = $this->input->post('driver_id');
      
        $_query =  $this->db->query("select * from booking where booking_id ='$booking_id' and driver_id='$driver_id' and is_deleted =0");
      if ($_query->num_rows() == 1)
      {       
                $rat = array('driver_rating' => $driver_rating , 'driver_rating_text' => $driver_rating_text);
                $this->db->where('booking_id',$booking_id);
                $this->db->update('booking', $rat); 
                
                 $data['user_info'] = $rat;
                 $data['msg'] = "done.";
                 $data['status'] =  REST_Controller::HTTP_OK;
      }else
      {                           
                 $data['user_info'] = "";
                 $data['msg'] = "Sorry! unable to rate this booking!";
                 $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
      }
   
      $this->response($data, REST_Controller::HTTP_OK);
    }

     public function mark_status_online_post()
    {
        $data = array();
        $driver_id = $this->input->post('driver_id');
        $status = $this->input->post('status');
    
        $query = $this->db->query("SELECT * FROM drivers WHERE driver_id = ? AND is_deleted = 0", array($driver_id));
        $result1 = $query->result();
    
        if ($query->num_rows() == 1) {
            $update_data = array('login_status' => $status );
            $this->db->where('driver_id', $driver_id);
            $this->db->update('drivers', $update_data);
    
            $data['booking_info'] = $update_data;
            $data['msg'] = " successfully";
            $data['status'] = REST_Controller::HTTP_OK;
        } else {
            $data['user_info'] = "";
            $data['msg'] = "fail";
            $data['status'] = REST_Controller::HTTP_NOT_FOUND;
        }
    
        $this->response($data, REST_Controller::HTTP_OK);
    }
    
    
    public function get_driver_bank_post()
    {
        $data = array();
        $driver_id = $this->input->post('driver_id');
    
        $query = $this->db->query("SELECT * FROM drivers WHERE driver_id = ? AND is_deleted = 0", array($driver_id));
        $result1 = $query->result();
    
        if ($query->num_rows() == 1) {
    
            $data['driver_detail'] = $result1;
            $data['msg'] = " successfully";
            $data['status'] = REST_Controller::HTTP_OK;
        } else {
            $data['user_info'] = "";
            $data['msg'] = "fail";
            $data['status'] = REST_Controller::HTTP_NOT_FOUND;
        }
    
        $this->response($data, REST_Controller::HTTP_OK);
    }
    

     public function user_driver_booking_list_post()
	{
        $driver_id = $this->input->post('driver_id');
        $booking_status = $this->input->post('booking_status');
       
        $data= array();
        
        if(isset($driver_id) && isset($booking_status) )
        {
            
        //   $booking_status = "completed,inprogress";
            $booking_statuses = explode(",", $booking_status);
            $this->db->select('booking.*,drivers.driver_name,drivers.driver_email,drivers.cell_number,app_users.user_name,app_users.phone_number,app_users.email');
            $this->db->from('booking');
            $this->db->where('booking.is_deleted', '0');
            $this->db->where('booking.driver_id', $driver_id);
            $this->db->where_in('booking.booking_status', $booking_statuses);
            
            $this->db->join('drivers', 'booking.driver_id = drivers.driver_id');
             $this->db->join('app_users', 'app_users.user_id=booking.user_id');
            $query = $this->db->get();
	        
              if ($query->num_rows()>=1)
              {
                $rows = $query->result_array();
                $data['bookings'] = $rows;
                $data['msg'] = "success";
                $data['status'] =  REST_Controller::HTTP_OK;
              }
              else
              {
              $data['bookings'] = "";
              $data['status'] =REST_Controller::HTTP_NOT_FOUND;
              $data['msg']="invalid user id || no bookings found.";
              }
        }

         $this->response($data, REST_Controller::HTTP_OK);
    }
    

public function insurance_reg_post()
{
    $posted= array();
    $insurance_company  = $this->input->post('insurance_company');
    $policy  = $this->input->post('policy');
    $insured_name   = $this->input->post('insured_name');
    $tow_truck_make_id=$this->input->post('tow_truck_make_id');
    $tow_model_id=$this->input->post('tow_model_id');
    $tow_year=$this->input->post('tow_year');
    $vin=$this->input->post('vin');
    $cell_number=$this->input->post('cell_number');
     
    $posted=array('insurance_company'=>$insurance_company,
        'policy'=>$policy,'insured_name'=>$insured_name
        ,'tow_truck_make_id'=>$tow_truck_make_id,'tow_model_id'=>$tow_model_id,'tow_year'=>$tow_year,'vin'=>$vin);
        
     if(isset($policy) && isset($insured_name) && isset($insurance_company) && isset($vin) ){

            $this->db->where('cell_number',$cell_number);
            $this->db->update('drivers',$posted);
            $data['data'] = $posted;
             $data['msg'] = "Insurance Updated.";
            $data['status'] =  REST_Controller::HTTP_OK;

           

          }else
          {
             $data['data'] = $posted;
             $data['msg'] = "incomplete Insurance information";
             $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
          }

          $this->response($data, REST_Controller::HTTP_OK);
}
    
public function company_reg_post()
{
                $posted= array();
                // $company_email  = $this->input->post('company_email');
                // $password  = $this->input->post('password');
                
                $company_id  = $this->input->post('company_id');
                $company_name  = $this->input->post('company_name');
                $license_number   = $this->input->post('license_number');
                $company_address=$this->input->post('company_address');
                $company_city=$this->input->post('company_city');
                $state_id= $this->input->post('state_id');
                $zip_code=$this->input->post('zip_code');
                $tax_id=$this->input->post('tax_id');
                
                // $query = $this->db->query("select * from companies where company_email='$company_email'");
                 
        //  if ($query->num_rows()>=1)
        // {
        //       $row = $query->row();
        //       $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
        //       $data['msg'] = "Email address already exist.";
        //       $this->response($data, REST_Controller::HTTP_NOT_FOUND);
        //       return;
        // }
        
        // $password=md5($password);
        
        $posted=array(
            'company_name'=>$company_name,
           'license_number'=>$license_number,'company_address'=>$company_address,'company_city'=>$company_city,
           'state_id'=>$state_id,'zip_code'=>$zip_code,'tax_id'=>$tax_id,);
                                
             if( isset($company_name) && isset($license_number) && isset($company_address)&& isset($company_city) 
             && isset($state_id) && isset($zip_code) &&isset ($tax_id)){
                          $this->db->where('company_id',$company_id);
                          $this->db->update('companies',$posted);
                         $data['data'] = $posted;
                         $data['msg'] = "success";
                         $data['status'] =  REST_Controller::HTTP_OK;
                 }else
                  {
                          
                         $data['msg'] = "fail";
                         $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
                  }
              $this->response($data, REST_Controller::HTTP_OK);
    }
    
public function reg_bank_account_post()
{
         
         $posted= array();
         $bank_account_holder=$this->input->post('bank_account_holder');
         $bank_account_number=$this->input->post('bank_account_number');
         $routing=$this->input->post('routing');
         $bank_name=$this->input->post('bank_name');
         $bank_address=$this->input->post('bank_address');
         $company_email=$this->input->post('company_email');
         
          $posted=array('bank_account_holder'=>$bank_account_holder,
            'bank_account_number'=>$bank_account_number,'routing'=>$routing
            ,'bank_name'=>$bank_name,'bank_address'=>$bank_address);
            
             if(isset($bank_account_holder) && isset($bank_account_number) && isset($routing) && isset($company_email) ){
                 
                $this->db->where('company_email',$company_email);
                $this->db->update('companies',$posted);
                $data['data'] = $posted;
                 $data['msg'] = "Bank Account Added.";
                $data['status'] =  REST_Controller::HTTP_OK;
                 
             }
        else
              {
                 $data['data'] = $posted;
                 $data['msg'] = "incomplete Bank information";
                 $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
              }
    
              $this->response($data, REST_Controller::HTTP_OK);
            

        }
        public function edit_driver_bank_account_post()
        {
         
             $posted= array();
             $bank_account_holder=$this->input->post('bank_account_holder');
             $bank_account_number=$this->input->post('bank_account_number');
             $routing=$this->input->post('routing_number');
             $bank_name=$this->input->post('bank_name');
             $bank_address=$this->input->post('bank_address');
             $driver_id=$this->input->post('driver_id');
             
              $posted=array('bank_account_holder'=>$bank_account_holder,
                'bank_account_number'=>$bank_account_number,'routing_number'=>$routing
                ,'bank_name'=>$bank_name,'bank_address'=>$bank_address);
                
             if(isset($bank_account_holder) && isset($bank_account_number) && isset($routing) && isset($driver_id) ){
                 
                $this->db->where('driver_id',$driver_id);
                $this->db->update('drivers',$posted);
                $data['data'] = $posted;
                 $data['msg'] = "Bank Account Added.";
                $data['status'] =  REST_Controller::HTTP_OK;
                 
             }
              else
              {
                 $data['data'] = $posted;
                 $data['msg'] = "incomplete Bank information";
                 $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
              }
    
              $this->response($data, REST_Controller::HTTP_OK);
            

        }
        
        


        
         public function update_email_post()
    {
      $data = array();
      $driver_id=$this->input->post('driver_id');
      $new_email=$this->input->post('new_email');
      $old_email=$this->input->post('old_email');
      
     
      $oldpass_query = $this->db->query("select * from drivers where driver_id='$driver_id' and driver_email='$old_email'");
      if ($oldpass_query->num_rows() >= 1)
      {       
                
                $s = array('driver_email' => $new_email);
                $this->db->where('driver_id',$driver_id);
                $this->db->update('drivers', $s); 

                 $data['msg'] = "Email updated successfully";
                 $data['status'] =  REST_Controller::HTTP_OK;
      }else
      {
                 $data['msg'] = "Sorry! unable to update Email";
                 $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
      }
   
      $this->response($data, REST_Controller::HTTP_OK);
    }
    
    public function update_phone_number_post()
    {
      $data = array();
      $driver_id=$this->input->post('driver_id');
      $new_phone_number=$this->input->post('new_phone_number');
      $old_phone_number=$this->input->post('old_phone_number');
      
     
      $oldpass_query = $this->db->query("select * from drivers where driver_id='$driver_id' and cell_number='$old_phone_number'");
      if ($oldpass_query->num_rows() >= 1)
      {       
                
                $s = array('cell_number' => $new_phone_number);
                $this->db->where('driver_id',$driver_id);
                $this->db->update('drivers', $s); 

                 $data['msg'] = "Phone Number updated successfully";
                 $data['status'] =  REST_Controller::HTTP_OK;
      }else
      {
                 $data['msg'] = "Sorry! unable to update Phone Number";
                 $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
      }
   
      $this->response($data, REST_Controller::HTTP_OK);
    }
    
    public function booking_driver_post()
    {
         $booking_id=$this->input->post('booking_id');
         
          
            $this->db->select('booking.*,drivers.driver_name ,drivers.fcm_id as driver_fcm_id ,drivers.driver_email,drivers.cell_number,app_users.fcm_id as user_fcm_id , app_users.user_name,app_users.phone_number,app_users.email');
	    	$this->db->from('booking');
	        $this->db->where('booking.is_deleted','0');
	       // $this->db->where('drivers.driver_id',$driver_id);
	         $this->db->where('booking.booking_id',$booking_id);
	        $this->db->join('drivers', 'booking.driver_id=drivers.driver_id' , 'left');
            $this->db->join('app_users', 'app_users.user_id=booking.user_id');
	        $query=$this->db->get();
	        
              if ($query->num_rows()>=1)
              {
                $rows = $query->result_array();
                $data['user'] = $rows;
                $data['msg'] = "success";
                $data['status'] =  REST_Controller::HTTP_OK;
              }
              else
              {
                $rows = $query->result_array();
              $data['user'] = $rows;
              $data['status'] =REST_Controller::HTTP_NOT_FOUND;
              $data['msg']="invalid user id || no bookings found.";
              }
        

         $this->response($data, REST_Controller::HTTP_OK);
     
    }

    public function update_insurence_post()
    {
      $data = array();
      $driver_id=$this->input->post('driver_id');
      $insurance_company=$this->input->post('insurance_company');
      $insured_name=$this->input->post('insured_name');
      
     
      $oldpass_query = $this->db->query("select * from drivers where driver_id='$driver_id'");
      if ($oldpass_query->num_rows() >= 1)
      {       
                
                $s = array('insurance_company' => $insurance_company , 'insured_name' => $insured_name);
                $this->db->where('driver_id',$driver_id);
                $this->db->update('drivers', $s); 

                 $data['msg'] = "Insurence updated successfully";
                 $data['status'] =  REST_Controller::HTTP_OK;
      }else
      {
                 $data['msg'] = "Sorry! unable to update Insurence";
                 $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
      }
   
      $this->response($data, REST_Controller::HTTP_OK);
    }
    
    
    public function driver_update_license_post()
{
         $posted= array();
         $license_number  = $this->input->post('license_number');
         $license_issue_date  = $this->input->post('license_issue_date');
         $license_expiration_date  = $this->input->post('license_expiration_date');
         $date_of_birth  = $this->input->post('date_of_birth');
         $state_id= $this->input->post('state_id');
         $license_type_id=$this->input->post('license_type_id');
         $company_id=$this->input->post('company_id');
         $cell_number=$this->input->post('cell_number');
         $driver_id=$this->input->post('driver_id');
         $password=$this->input->post('password');
         $fcm_id  = $this->input->post('fcm_id');
         
           $password=md5($password);
         
         $posted=array('license_number'=>$license_number,
            'license_issue_date'=>$license_issue_date,'license_expiration_date'=>$license_expiration_date
            ,'date_of_birth'=>$date_of_birth,'state_id'=>$state_id,'license_type_id'=>$license_type_id,'company_id'=>$company_id , 'password'=>$password ,'fcm_id'=>$fcm_id);
            
         if( isset($company_id) && isset($license_type_id) && isset($state_id) ){
    
                $this->db->where('driver_id',$driver_id);
                $this->db->update('drivers',$posted);
                $data['data'] = $posted;
                 $data['msg'] = "Registration Updated.";
                $data['status'] =  REST_Controller::HTTP_OK;
    
               
    
              }else
              {
                 $data['data'] = $posted;
                 $data['msg'] = "incomplete driver information";
                 $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
              }
    
              $this->response($data, REST_Controller::HTTP_OK);
}
    public function driver_update_tow_truck_post()
    {
         $posted= array();
         $tow_truck_make_id  = $this->input->post('tow_truck_make_id');
         $tow_year  = $this->input->post('tow_year');
         $tow_model_id  = $this->input->post('tow_model_id');
         $tow_truck_type_id  = $this->input->post('tow_truck_type_id');
         $driver_id  = $this->input->post('driver_id');
         
         $posted=array(
                    'tow_truck_make_id'=>$tow_truck_make_id,
                    'tow_year'=>$tow_year,
                    'tow_model_id'=>$tow_model_id,
                    'tow_truck_type_id'=>$tow_truck_type_id
            );
            
         if( isset($driver_id) ){
    
                $this->db->where('driver_id',$driver_id);
                $this->db->update('drivers',$posted);
                $data['data'] = $posted;
                 $data['msg'] = "Update Succesfully.";
                $data['status'] =  REST_Controller::HTTP_OK;
    
               
    
              }else
              {
                 $data['data'] = $posted;
                 $data['msg'] = "incomplete information";
                 $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
              }
    
              $this->response($data, REST_Controller::HTTP_OK);
    }
    
    
    	public function driver_earning_post()
	{
	   
        $driver_id = $this->input->post('driver_id');
        $data= array();
        if(isset($driver_id) )
        {
             $query = $this->db->query(" SELECT d.total_withdraw_amt , d.total_earning_amt  , d.total_earning_amt - d.total_withdraw_amt as remaining_amount from drivers d  where d.is_deleted =0 AND d.driver_id = $driver_id");

              if ($query->num_rows()==1)
              {
                $row = $query->row();
               
                $data['driver_earning'] = $row;
                //"success";
                $data['msg'] = "success";
                $data['status'] =  REST_Controller::HTTP_OK;
              
                //exit();
                // $s = array('user_status' => 1,'last_signin'=>$last_signin);
                // $this->db->where('driver_id',$row->driver_id);
                // $this->db->update('drivers', $s); 
               
              }
              else
              {
              $data['driver_earning'] = array('remaining_amount'=>"",
                							'total_earning_amt'=>"",
                							'total_withdraw_amt'=>""
                							
                						);;
              $data['status'] =REST_Controller::HTTP_NOT_FOUND;
              $data['msg']="fail.";
              }
        }

         $this->response($data, REST_Controller::HTTP_OK);
    }

    public function signup_driver_post()
    {
        $posted= array();
        $driver_name   = $this->input->post('driver_name');
        $driver_email  = $this->input->post('driver_email');
        $cell_number   = $this->input->post('cell_number');
        $password  = $this->input->post('password');
        

        $query = $this->db->query("select * from drivers where driver_email='$driver_email' AND cell_number='$cell_number'");
        
        if ($query->num_rows()>=1)
        {
          $row = $query->row();
          $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
          $data['msg'] = "Email address already exist.";
          $this->response($data, REST_Controller::HTTP_NOT_FOUND);
          return;
        }

        $password=md5($password);

        $posted = array('driver_name' => $driver_name,'driver_email'=>$driver_email,'cell_number'=>$cell_number,'password'=>$password );

         if(isset($driver_name) && isset($driver_email) && isset($password) && isset($cell_number) ){

            $this->db->insert('drivers',$posted);
            $data['data'] = $posted;
             $data['msg'] = "saved";
            $data['status'] =  REST_Controller::HTTP_OK;

          }else
          {
             $data['msg'] = "incomplete driver information";
         $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
          }

          $this->response($data, REST_Controller::HTTP_OK);

    }

public function forgot_password_post()
{
        $driver_email  = $this->input->post('driver_email');
        $cell_number  = $this->input->post('cell_number');
        
        $query = $this->db->query("select * from drivers where driver_email='$driver_email'AND  cell_number = '$cell_number' AND is_approved=1");
      if ($query->num_rows()>=1)
      {
        $row = $query->row();
        $data['status'] =  REST_Controller::HTTP_OK;
        $data['msg'] = "Email and Cell No exists.";
      }else
      {
         $data['msg'] = "email address or password not found.";
         $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
        }
    $this->response($data, REST_Controller::HTTP_OK);


  }

public function signin_post()
{
        $phone_number = $this->input->post('phone_number');
        $password = $this->input->post('password');
        $data= array();
        if(isset($phone_number) && isset($password))
        {
             $passwordupdate = md5($password);
             $is_deleted = "0";
             $query = $this->db->query("select * from drivers where cell_number='$phone_number' AND password='$passwordupdate'");

              if ($query->num_rows()==1)
              {
                $row = $query->row();
                $data['driver_info'] = array('driver_id'=>$row->driver_id,
                							'driver_name'=>$row->driver_name,
                							'cell_number'=>$row->cell_number,
                							'driver_email'=>$row->driver_email,
                							'license_number'=>$row-> license_number,
                							'tow_truck_make_id'=>$row->tow_truck_make_id,
                						    'insurance_company'=>$row->insurance_company,
                						    'fcm_id'=>$row->fcm_id
                						);
                //"success";
                $data['msg'] = "success";
                $data['status'] =  REST_Controller::HTTP_OK;
                $last_signin=date('Y-m-d H:i:s');
                //exit();
                $s = array('login_status' => 1,'last_signin'=>$last_signin);
                $this->db->where('driver_id',$row->driver_id);
                $this->db->update('drivers', $s); 
               
              }
              else
              {
              $data['driver_info'] = array('driver_id'=>"",'driver_name'=>"",'cell_number'=>"",'driver_email'=>"");;
              $data['status'] =REST_Controller::HTTP_NOT_FOUND;
              $data['msg']="invalid phone number or password.";
              }
        }

         $this->response($data, REST_Controller::HTTP_OK);
    }

public function signout_post()
{
      
       $driver_id = $this->input->post('driver_id');
       $query = $this->db->query("select * from drivers where driver_id='$driver_id'");
       $data= array();
           if ($query->num_rows()==1)
              {
                 $row = $query->row();
                 $s = array('login_status' => 0);
                 $this->db->where('drivers',$drivers);
                 $this->db->update('drivers', $s);
                 $data['msg'] = "logout";
                 $data['status'] =REST_Controller::HTTP_OK;


              }else
              {
                  $data['msg'] = "invalid company id";
                  $data['status'] =REST_Controller::HTTP_NOT_FOUND;
              }
          $this->response($data, REST_Controller::HTTP_OK);
    }


public function update_password_post()
{
		  $data = array();
		  $driver_id=$this->input->post('driver_id');
		  $new_password=$this->input->post('new_password');
		  $old_password=$this->input->post('old_password');
		  
		  $oldPasswordEncr = md5($old_password);
		  $oldpass_query = $this->db->query("select * from drivers where driver_id='$driver_id' and password='$oldPasswordEncr'");
		  if ($oldpass_query->num_rows() >= 1)
		  {       
		            
		            $s = array('password' => md5($new_password));
		            $this->db->where('driver_id',$driver_id);
		            $this->db->update('drivers', $s); 

		             $data['msg'] = "Password updated successfully";
		             $data['status'] =  REST_Controller::HTTP_OK;
		  }else
		  {
		             $data['msg'] = "Sorry! unable to update password";
		             $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
		  }

		  $this->response($data, REST_Controller::HTTP_OK);
	}

public function user_booking_list_post()
{
        $driver_id = $this->input->post('driver_id');
        $booking_status = $this->input->post('booking_status');
       
        $data= array();
        
        if(isset($driver_id) && isset($booking_status) )
        {
            
            
            $this->db->select('booking.*,drivers.driver_name,drivers.driver_email,drivers.cell_number,app_users.user_name,app_users.phone_number,app_users.email');
	    	$this->db->from('booking');
	        $this->db->where('booking.is_deleted','0');
	        $this->db->where('drivers.driver_id',$driver_id);
	         $this->db->where('booking.booking_status',$booking_status);
	        $this->db->join('drivers', 'booking.driver_id=drivers.driver_id');
            $this->db->join('app_users', 'app_users.user_id=booking.user_id');
	        $query=$this->db->get();
	        
              if ($query->num_rows()>=1)
              {
                $rows = $query->result_array();
                $data['user'] = $rows;
                $data['msg'] = "success";
                $data['status'] =  REST_Controller::HTTP_OK;
              }
              else
              {
                $rows = $query->result_array();
              $data['user'] = $rows;
              $data['status'] =REST_Controller::HTTP_NOT_FOUND;
              $data['msg']="invalid user id || no bookings found.";
              }
        }

         $this->response($data, REST_Controller::HTTP_OK);
    }
    
public function update_booking_status_post(){
    // $data = array();
    $data=$this->input->post();
    $booking_id=$this->input->post('booking_id');
    // extract($this->input->post());
    
    // $s = array('booking_status' =>$booking_status);
    $this->db->where('booking_id',$booking_id);
	
	if($this->db->update('booking', $data))
	{
	    $data['booking']=$data ;
	    $data['msg'] = "Staus Updated Successfully";
		$data['status'] =  REST_Controller::HTTP_OK;
	    
	}else
	{
              $data['booking'] = $s;
              $data['status'] =REST_Controller::HTTP_NOT_FOUND;
              $data['msg']="Booking status update failed.";  
	}
	 $this->response($data, REST_Controller::HTTP_OK);	            
}


    public function update_driver_location_post(){
        $data = array();
        $driver_id = $this->input->post('driver_id');
        $lat = $this->input->post('lat');
        $lng = $this->input->post('lng');
        
        $s = array('lat' =>$lat,'lng'=>$lng);
       $this->db->where('driver_id',$driver_id);
        
        if($this->db->update('drivers',$s))
        {
            $data['driver_location'] = $s;
            $data['msg'] = "Location Updated Successfully";
            $data['status'] = REST_Controller::HTTP_OK;
        
        }
        else
        {
            $data['driver_location'] = $s;
            $data['msg'] = "Location Updated failed";
            $data['status'] = REST_Controller::HTTP_NOT_FOUND;
        }
        $this->response($data, REST_Controller::HTTP_OK);	
    }
    
    
    public function online_drivers_post()
{
    // Convert latitude and longitude from degrees to radians
    $query = $this->db->query("SELECT * FROM drivers where login_status = 1 AND is_deleted = 0 AND lat != 0 AND lng != 0");
    $result = $query->result();  // or $result = $query->result_array();

    $onlineDrivers = array();

    $lat1 = $this->input->post('lat1');
    $lon1 = $this->input->post('lng1');
    
    foreach ($result as $data) {
        $lat2 = $data->lat;
        $lon2 = $data->lng;

        $lat1 = deg2rad($lat1);
        $lon1 = deg2rad($lon1);
        $lat2 = deg2rad($lat2);
        $lon2 = deg2rad($lon2);
        

        // Calculate differences
        $dlat = $lat2 - $lat1;
        $dlon = $lon2 - $lon1;

        // Haversine formula
        $a = sin($dlat / 2) ** 2 + cos($lat1) * cos($lat2) * sin($dlon / 2) ** 2;
        $c = 2 * atan2(sqrt($a), sqrt(1 - $a));

        // Radius of the Earth in kilometers
        $radius = 6371;

        // Calculate the distance in kilometers
        $distanceKm = $radius * $c;

        // Convert kilometers to miles
        $distanceMiles = $distanceKm * 0.621371;
        
        $miles[] = $distanceMiles;
        if ($distanceMiles <= 40 && $distanceMiles > 0) {
            $onlineDrivers[] = $data->driver_id;
        }
    }
    // print_r($miles);
    //         die;


    if (!empty($onlineDrivers)) {
       
        $driverIds = implode(',', $onlineDrivers);
        $query = $this->db->query("SELECT * FROM drivers WHERE driver_id IN ($driverIds)");
        $result = $query->result();

        $dat['drivers'] = $result;
        $dat['status'] = REST_Controller::HTTP_OK;
    } else {
       
        $dat['msg'] = "No Driver Found";
        $dat['status'] = REST_Controller::HTTP_NOT_FOUND;
    }

    $this->response($dat, REST_Controller::HTTP_OK);
}


// header('Content-Type: application/json');

public function distance_miles_post() {
    


// Check if the required parameters are present in the POST request
if (isset($_POST['lat1'], $_POST['lng1'], $_POST['lat2'], $_POST['lng2'])) {
    // Extract values from the POST request
    $lat1 = floatval($_POST['lat1']);
    $lon1 = floatval($_POST['lng1']);
    $lat2 = floatval($_POST['lat2']);
    $lon2 = floatval($_POST['lng2']);

$lat1 = deg2rad($lat1);
    $lon1 = deg2rad($lon1);
    $lat2 = deg2rad($lat2);
    $lon2 = deg2rad($lon2);

    // Calculate differences
    $dlat = $lat2 - $lat1;
    $dlon = $lon2 - $lon1;

    // Haversine formula
    $a = sin($dlat / 2) ** 2 + cos($lat1) * cos($lat2) * sin($dlon / 2) ** 2;
    $c = 2 * atan2(sqrt($a), sqrt(1 - $a));

    // Radius of the Earth in kilometers
    $radius = 6371;

    // Calculate the distance in kilometers
    $distanceKm = $radius * $c;

    // Convert kilometers to miles
    $distance = $distanceKm * 0.621371;
    // Calculate the distance
    // $distance = haversineDistance($lat1, $lng1, $lat2, $lng2);

    // Return success response
    echo json_encode(['success' => true, 'distance' => $distance]);
} else {
    // Return failure response if parameters are missing
    echo json_encode(['success' => false, 'error' => 'Missing parameters']);
}




    }
    
    
    public function driver_location_post(){
        $data = array();
        $driver_id = $this->input->post('driver_id');
            $lat = $this->input->post('lat');
        $lng = $this->input->post('lng');
        
       
        $this->db->select('drivers.*');
	    	$this->db->from('drivers');
	        $this->db->where('drivers.is_deleted','0');
	       // $this->db->where('drivers.driver_id',$driver_id);
            
	        $query=$this->db->get();
	        
              if ($query->num_rows()>=1)
              {
                $rows = $query->result_array();
                $data['user'] = $rows;
                $data['msg'] = "success";
                $data['status'] =  REST_Controller::HTTP_OK;
              }
              else
              {
                $rows = $query->result_array();
              $data['user'] = $rows;
              $data['status'] =REST_Controller::HTTP_NOT_FOUND;
              $data['msg']="No Driver found.";
              }	
    }


      public function rating_post()
    {
        $data = array();
        $booking_id   = $this->input->post('booking_id');
        $rating_value   = $this->input->post('rating_value');
        $user_id   = $this->input->post('driver_id');
      
        $_query =  $this->db->query("select * from booking where booking_id ='$booking_id' and driver_id='$driver_id' and is_deleted =0");
      if ($_query->num_rows() == 1)
      {       
                
                $rat = array('user_rating' => $rating_value);
                $this->db->where('booking_id',$booking_id);
                $this->db->update('booking', $rat); 
                
                 $data['user_info'] = $rat;
                 $data['msg'] = "done.";
                 $data['status'] =  REST_Controller::HTTP_OK;
      }else
      {                           
                 $data['user_info'] = "";
                 $data['msg'] = "Sorry! unable to rate this booking!";
                 $data['status'] =  REST_Controller::HTTP_NOT_FOUND;
      }
   
      $this->response($data, REST_Controller::HTTP_OK);
    }

}
